import gc
import time
import pandas as pd
from tqdm import trange
from jax import grad, jacfwd, random, jit
import jax.numpy as np
from jax.config import config

T2, T3 = 10, 10
def g_3(f_3, x_1, x_2, x_3):
    g = jacfwd(f_3, 2)(x_1, x_2, x_3)
    return g

def phi_3(f_3, x_1, x_2, x_3):
    g = g_3(f_3, x_1, x_2, x_3)
    return x_3 - 0.01 * g

def g_2(f_2, f_3, x_1, x_2, x_3):
    Z_3 = 0
    x_3_ = x_3
    for t_3 in range(T3):
        J = jacfwd(phi_3, [2, 3])(f_3, x_1, x_2, x_3_)
        x_3_ = phi_3(f_3, x_1, x_2, x_3_)
        B_3 = J[0]
        A_3 = J[1]
        Z_3 = A_3 * Z_3 + B_3
    g = jacfwd(f_2, 1)(x_1, x_2, x_3_)
    g += jacfwd(f_2, 2)(x_1, x_2, x_3_) * Z_3
    return g, x_3_

def phi_2(f_2, f_3, x_1, x_2, x_3):
    g, x_3_ = g_2(f_2, f_3, x_1, x_2, x_3)
    return x_2 - 0.01 * g, x_3_

def simple_phi2(f_2, f_3, x_1, x_2, x_3):
    return phi_2(f_2, f_3, x_1, x_2, x_3)[0]

def g_1(f_1, f_2, f_3, x_1, x_2, x_3):
    # k = 2
    Z_2 = 0
    x_2_ = x_2
    x_3_ = x_3
    for t_2 in range(T2):
        J = jacfwd(simple_phi2, [2, 3])(f_2, f_3, x_1, x_2_, x_3_)
        x_2_, x_3_ = phi_2(f_2, f_3, x_1, x_2_, x_3_)
        B_2 = J[0]
        A_2 = J[1]
        Z_2 = A_2 * Z_2 + B_2
    # k = 3
    Z_3 = 0
    for t_3 in range(T3):
        J = jacfwd(phi_3, [1, 2, 3])(f_3, x_1, x_2_, x_3_)
        x_3_ = phi_3(f_3, x_1, x_2_, x_3_)
        B_3 = J[0]
        C_32 = J[1]
        A_3 = J[2]
        B_3 += C_32 * Z_2
        Z_3 = A_3 * Z_3 + B_3
    g = jacfwd(f_1, 0)(x_1, x_2_, x_3_)
    g += jacfwd(f_1, 1)(x_1, x_2_, x_3_) * Z_2
    g += jacfwd(f_1, 2)(x_1, x_2_, x_3_) * Z_3
    return g, x_2_, x_3_